
/* Maintained and distributed by Alex Bodnaru under the terms of the
   GNU Library General Public License.

   Created by, and Copyright (C) 2002 Alex Bodnaru.

This file is part of libgrx, a portable library for 2D graphics written in c

libextra is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation (version 2).

libextra is distributed "AS IS" in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied
warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with libextra; see the file COPYING.  If not, write
to the Free Software Foundation, 675 Mass Ave, Cambridge,
MA 02139, USA.

Report problems and direct all questions to:

  alexbodn@012.net.il
*/


#include <conio.h>
#include <stdio.h>
#include <string.h>

int main()
{
    typedef struct
    {
     int _left, _top, _right, _bottom;
    } win_t;
    win_t a = {10, 10, 19, 19};
    win_t b = {30, 11, 39, 20};
    win_t c = {50, 12, 59, 21};
    win_t d = {52, 14, 57, 19};
    char *ruler = "0123456789"
                  "0123456789"
                  "0123456789"
                  "0123456789"
                  "0123456789"
                  "0123456789"
                  "0123456789"
                  "0123456789"
                  "0123456789"
                  "012345678"; /*one missing so don't scroll*/
    char *text = "Hello GRX conio";
    char *mltext = "multiline\r\ntext: spans\r\non three lines";
    char ch;
    /**/double to_scanf = 0.0;/**/
    char to_cgets[20];
    unsigned short buf[600];
#ifdef __GNUC__
    gppconio_init();
#endif
    textcolor(LIGHTRED);
    textbackground(BLUE);
    _setcursortype(_SOLIDCURSOR);
    clrscr();
    cputs(text);
    movetext(1, 1, strlen(text), 1, 2, 2);
    movetext(2, 2, 1 + strlen(text), 2, 3, 3);
    gotoxy(11, 1);
    clreol();
    textcolor(YELLOW);
    textbackground(LIGHTRED);
    cputs(text);

    window(a._left, a._top, a._right, a._bottom);
    cputs(ruler);
    window(b._left, b._top, b._right, b._bottom);
    textcolor(GREEN);
    cputs(ruler);
    movetext(b._left, b._top, b._right, b._bottom, c._left, c._top);
    gettext(d._left, d._top, d._right, d._bottom, buf);
    puttext(d._left - 12, d._top - 12, d._right - 12, d._bottom - 12, buf);
    window(d._left - 12, d._top - 12, d._right - 12, d._bottom - 12);
    gotoxy(2, 2);
    clreol();
    gotoxy(2, 3);
    delline();
    delline();
    _setcursortype(10); /*should ignore*/
    gotoxy(2, 4);
    insline();
    window(a._left + 10, a._top + 10, a._right + 10, d._bottom + 10);
    cputs(mltext);
    window(a._left, a._top + 11, a._right, d._bottom + 11);
    _setcursortype(_NORMALCURSOR);
    textbackground(BROWN);
    clrscr();
    cputs("please write your own text, press esc to end.");
    while (!kbhit())
          ;
    clrscr();
    for (ch = 0; (ch = getch()) != '\033'; )
    {
        putch(ch);
        if (ch == '\r')
           putch('\n');
    }
    ungetch(ch); /*esc*/
    while (!kbhit())/*don't wait, since esc is waiting*/
          ;
    getch(); /*esc*/
/*not working yet*/
/*
    cputs("please write a double number and \\r");
    cscanf("%g", &to_scanf);
    cprintf("the scanned number is %g. press any key", to_scanf);
    getch();
    getch();
*/
    clrscr();
    cputs("please write a string. maximum 10 chars will be read:");
    to_cgets[0] = 10;
    cgets(to_cgets);
    clrscr();
    cputs("the string is:");
    cputs(to_cgets + 2);
    cputs("press any key to end test");
    while (!kbhit())
          ;
    return 0;
}

